#ifndef SPLINE_FIT_BEZIER_H
#define SPLINE_FIT_BEZIER_H

/*utils functions for vectorization*/

#include "point.h"
#include "global_param.h" //store PI
#include <QVector>
#include <iostream>
#include <assert.h>
using namespace std;
/**
 *  Assign parameter values to digitized points using relative distances between points.
 *  use for data represented by one cubic Bezier
 */
void
chord_length_parameterize(QVector<Point>* d, QVector<double>* u );

/**
 *  Estimates length of tangent vectors P1, P2, when direction is given
 *  fills in bezier with the correct values for P1, P2
 *  Point bezier[4]
 */
void
estimate_lengths(Point bezier[],
                 QVector<Point> data, QVector<double> uPrime,
                 Point const &tHat1, Point const &tHat2);
#endif