#ifndef GLSLPROGRAM_H
#define GLSLPROGRAM_H

#include <GL/glew.h>
#include <string>
#include <map>

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of GLSLProgram
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class GLSLProgram
{
public:
  GLSLProgram();
  bool create(const char* vFileName,const char* fFileName);
  bool reload(const char* vFileName,const char* fFileName);
  const std::string& lastError();

  GLint operator[](const std::string&) const;
  void activate();
  void deactivate();
private:
  bool                                created_;
  GLhandleARB                         vShader_;
  GLhandleARB                         fShader_;
  GLhandleARB                         program_;
  mutable std::map<std::string,GLint> params_;
  std::string                         error_;
};

#endif // GLSLPROGRAM_H
