#include "poissonViewer.h"
#include <qimage.h>
#include <QKeyEvent>
#include <QFileDialog>

# include <QMenu>
# include <QMouseEvent>
//#include <qcursor.h>
//#include <qmap.h>

using namespace std;

void Viewer::drawCatmull_keyPressEvent(QKeyEvent* e)
{
	switch (e->key())
	{
	// Calls the original method to handle other keys
	default: 
		QGLViewer::keyPressEvent(e);
	}
}

void Viewer::drawCatmull_mousePressEvent(QMouseEvent* e)
{
	if ( e->button() == Qt::LeftButton )
	{
		drawFreeHandPath.clear();
		drawFreeHandZoomed.clear();
		splines.setSelected(-1);
		double x,y;
		Point mousePoint;
		x = e->x()/(0.5*width())-1;
		y = 1-e->y()/(0.5*height());
		x/=zoom;
		y/=zoom;
		x-= center_x;
		y-= center_y;
		mousePoint.setX(x); mousePoint.setY(y);
		drawFreeHandPath.push_back(mousePoint);
		mousePoint.setX(e->x()); mousePoint.setY(e->y());
		drawFreeHandZoomed.push_back(mousePoint);
	}
	else
		QGLViewer::mousePressEvent(e);
}

void Viewer::drawCatmull_mouseMoveEvent(QMouseEvent* e)
{
	Point mousePoint; double x,y;
	//can't check for left button, the returned value is always Qt::NoButton for mouse move events.
	switch (drawFreeHandPath.isEmpty())
	{
	case false :
		x = e->x()/(0.5*width())-1;
		y = 1-e->y()/(0.5*height());
		x/=zoom;
		y/=zoom;
		x-= center_x;
		y-= center_y;
		mousePoint.setX(x); mousePoint.setY(y);
		drawFreeHandPath.push_back(mousePoint);
		mousePoint.setX(e->x()); mousePoint.setY(e->y());
		drawFreeHandZoomed.push_back(mousePoint);
		break;
	default:
		QGLViewer::mouseMoveEvent(e);
	}

}

void Viewer::drawCatmull_mouseReleaseEvent(QMouseEvent* e)
{
	switch (e->button())
	{
	case Qt::LeftButton :
		if(drawFreeHandPath.size()>3)
		{
			splines.fitSpline(drawFreeHandZoomed, width(), height(), zoom, center_x, center_y);
			splines.setSelected(-1);
		}
		drawFreeHandPath.clear();
		drawFreeHandZoomed.clear();
		//double x,y;
		//x = e->x()/(0.5*width())-1;
		//y = 1-e->y()/(0.5*height());
  //              x/=zoom;
  //              y/=zoom;
  //              x-= center_x;
  //              y-= center_y;
  //              //if the left or right color are activated, don't read them in the reference buffer
		//splines.addPoint(x,y);
		//splines.addLeftColorPoint(!bLeft,  x, y);
		//splines.addRightColorPoint(!bRight,  x, y);
		//splines.addBlurPoint(-1);
		
                poissonSolver->updateReference();
		poissonSolver->slowUpdate();
		break;
	default: QGLViewer::mouseReleaseEvent(e);
	}
}
