#include "poissonViewer.h"
#include <qimage.h>
#include <QKeyEvent>
#include <QFileDialog>

# include <QMenu>
# include <QMouseEvent>
//#include <qcursor.h>
//#include <qmap.h>

using namespace std;

void Viewer::pan_keyPressEvent(QKeyEvent* e)
{
    QGLViewer::keyPressEvent(e);
}

void Viewer::pan_mousePressEvent(QMouseEvent* e)
{
    if ( e->button() == Qt::LeftButton ){
        isPanning=true;
        //init the origin of the panning vector
        pan_x0 = e->x()/(0.5*width())-1;
        pan_y0 = 1-e->y()/(0.5*height());
        pan_x0/=zoom;
        pan_y0/=zoom;
        pan_x0-= center_x;
        pan_y0-= center_y;
    }
    else
        QGLViewer::mousePressEvent(e);
}

void Viewer::pan_mouseMoveEvent(QMouseEvent* e)
{
    if ( isPanning){
        //compute the panning vector
        pan_x1 = e->x()/(0.5*width())-1;
        pan_y1 = 1-e->y()/(0.5*height());
        pan_x1/=zoom;
        pan_y1/=zoom;
        pan_x1-= center_x;
        pan_y1-= center_y;
        center_x += pan_x1-pan_x0;
        center_y += pan_y1-pan_y0;
        poissonSolver->setCenterX(center_x);
        poissonSolver->setCenterY(center_y);
        poissonSolver->fastUpdate();
        //compute the new the origin of the panning vector
        pan_x0 = e->x()/(0.5*width())-1;
        pan_y0 = 1-e->y()/(0.5*height());
        pan_x0/=zoom;
        pan_y0/=zoom;
        pan_x0-= center_x;
        pan_y0-= center_y;
    }
    else
        QGLViewer::mousePressEvent(e);
}

void Viewer::pan_mouseReleaseEvent(QMouseEvent* e)
{
    if ( e->button() == Qt::LeftButton ){
        isPanning=false;
        poissonSolver->slowUpdate();
    }
    else
        QGLViewer::mouseReleaseEvent(e);
}
