#include <iostream>


class Matrix{

public:

// Maxime : most of those methods were first declared "inline". I changed that 
// because it was responsible for a g++ Warning: 'XXX' used but never defined
// I could not figure it out so...

    //@{
    //! Classical constructor.
  
    Matrix(int N,int M,double defVal); // Create a defVal matrix of size N_row*N_col
    Matrix(int N,int M); // Create a matrix of size N_row*N_cols
    //explicit inline Matrix(int N_row,int N_col, tab[N_row][N_col]);
    //inline Matrix(const Matrix<N_row,N_col,Real>& m); 
    ~Matrix();
    //@}

    Matrix transpose() const; 
    Matrix inverse()const;



	int getNbRow();
	int getNbCol();
	
    //@{
    //! Classical operator.
  
    Matrix& operator=(const Matrix& m);
    Matrix& operator+=(const Matrix& m);
    Matrix& operator-=(const Matrix& m);
    Matrix& operator*=(const double& lambda);
    Matrix& operator/=(const double& lambda);
    Matrix operator-() const;
    //@}

    //@{
    //! Classical access operator.

    const double& operator()(const int i,const int j) const;
    double& operator()(const int i,const int j);

    //@}

  
    //@{
    //! Classical operator.

    friend Matrix
    operator+(const Matrix& m1, const Matrix& m2);

    
    friend Matrix
    operator*(const Matrix& m, const double lambda);

    friend Matrix
    operator*(const double lambda, const Matrix& m);

    friend Matrix // Exception must be raised in case of dimension conflict
    operator*(const Matrix& m1, const Matrix& m2);

    friend Matrix // Exception must be raised in case of dimension conflict
    operator/(const Matrix& m, const double lambda);

    //@}


    //@{
    //! Row and column operators

    void swap_rows(const int row1,const int row2);
    void multiply_row(const int row,const double lambda);
    Matrix get_vector_from_row(const int row) const; // The result matrix is a (1,N) matrix
    // m must be a (1,N_col) matrix, otherwise an Exception must be raised
    void add_vector_to_row(const int row,const Matrix& m); 

    //@}
    
    // Display function
    void display();
    
  private:
  
    inline void createComponent(int N,int M);
    inline void freeComponent();
    
    int N_row,N_col;
    double** component;

};

