#ifndef POINT_H
#define POINT_H

#include <math.h>

class Point  
{
public:
	Point(){x=0;y=0;};
	Point(double i, double j){x=i;y=j;};
	//Point(const Point p);{x=p.x;y=p.y;};
	double getX() {return x;};
	double getY() {return y;};
	void setX(double i) {x=i;};
	void setY(double j) {y=j;};

	void normalize() {double norm = hypot(x, y); x/=norm;y/=norm;};
	double L2_norm() const{return hypot(x, y);};
	bool is_zero() const{ return ( x == 0 && y == 0 );};

	const Point operator -(const Point P) const{return Point(x - P.x, y - P.y);};
	const Point operator +(const Point P) const{return Point(x + P.x, y + P.y);};
	const Point operator *(double a) const{return Point(a*x, a*y);};
	const Point operator /(double a) const{return a!=0 ? Point(x/a, y/a) : Point(x,y);};

	const Point operator -() const{return Point(-x, -y);};
	
	bool operator !=(Point& P){if(x!=P.x || y!=P.y) return true; return false;};
	bool operator ==(Point& P){if(x==P.x && y==P.y) return true; return false;};
	virtual ~Point() {};

	double x,y;
private:
	//double x,y;
};

#endif
