uniform sampler2DRect imgMap, blurMap;
uniform float blur;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

	//pixel and neighbours
        /*vec4 imgHG = texture2DRect(imgMap,pixCoord+vec2(-1,-1));
        vec4 imgHD = texture2DRect(imgMap,pixCoord+vec2(1,-1));*/
        vec4 imgH = texture2DRect(imgMap,pixCoord+vec2(0,-1));
        vec4 imgG = texture2DRect(imgMap,pixCoord+vec2(-1,0));
        vec4 img = texture2DRect(imgMap,pixCoord);
	vec4 imgD = texture2DRect(imgMap,pixCoord+vec2(1,0));
        vec4 imgB = texture2DRect(imgMap,pixCoord+vec2(0,1));
        /*vec4 imgBD = texture2DRect(imgMap,pixCoord+vec2(1,1));
        vec4 imgBG = texture2DRect(imgMap,pixCoord+vec2(-1,1));*/

        //blur values of the neighbours
        /*vec4 blurHG = texture2DRect(blurMap,pixCoord+vec2(-1,-1));
        vec4 blurHD = texture2DRect(blurMap,pixCoord+vec2(1,-1));*/
        vec4 blurH = texture2DRect(blurMap,pixCoord+vec2(0,-1));
        vec4 blurG = texture2DRect(blurMap,pixCoord+vec2(-1,0));
	vec4 blurD = texture2DRect(blurMap,pixCoord+vec2(1,0));
	vec4 blurB = texture2DRect(blurMap,pixCoord+vec2(0,1));
        /*vec4 blurBD = texture2DRect(blurMap,pixCoord+vec2(1,1));
        vec4 blurBG = texture2DRect(blurMap,pixCoord+vec2(-1,1));*/

        if(blurG[0]>=blur){
            blurG[0]=0.25;
        }
        else{
            blurG[0]=0.0;
        }

        if(blurD[0]>=blur){
            blurD[0]=0.25;
        }
        else{
            blurD[0]=0.0;
        }

        if(blurH[0]>=blur){
            blurH[0]=0.25;
        }
        else{
            blurH[0]=0.0;
        }

        if(blurB[0]>=blur){
            blurB[0]=0.25;
        }
        else{
            blurB[0]=0.0;
        }

        /*if(blurHG[0]>=blur){
            blurHG[0]=0.0625;
        }
        else{
            blurHG[0]=0.0;
        }

        if(blurHD[0]>=blur){
            blurHD[0]=0.0625;
        }
        else{
            blurHD[0]=0.0;
        }

        if(blurBG[0]>=blur){
            blurBG[0]=0.0625;
        }
        else{
            blurBG[0]=0.0;
        }

        if(blurBD[0]>=blur){
            blurBD[0]=0.0625;
        }
        else{
            blurBD[0]=0.0;
        }*/

        float w = 1.0-blurG[0]-blurD[0]-blurH[0]-blurB[0]/*-blurHG[0]-blurHD[0]-blurBG[0]-blurBD[0]*/;

	vec4 result = w*img+blurG[0]*imgG+blurD[0]*imgD+blurH[0]*imgH+blurB[0]*imgB
                            /*+blurHG[0]*imgHG+blurHD[0]*imgHD+blurBG[0]*imgBG+blurBD[0]*imgBD*/;

        result = clamp(result,vec4(0,0,0,1),vec4(1,1,1,1));

        gl_FragColor = result;
}
