uniform sampler2DRect imgMap;
uniform float scale;
//scale corresponds to the scaling factor when accessing to
//the result of a coarser level in the multigrid

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

        //Jacobi iteration
        vec4 imgG = texture2DRect(imgMap,scale*pixCoord+vec2(-1,0));
	vec4 imgD = texture2DRect(imgMap,scale*pixCoord+vec2(1,0));
	vec4 imgH = texture2DRect(imgMap,scale*pixCoord+vec2(0,-1));
	vec4 imgB = texture2DRect(imgMap,scale*pixCoord+vec2(0,1));

        /*vec4 imgGG = texture2DRect(imgMap,scale*pixCoord+vec2(-2,0));
	vec4 imgDD = texture2DRect(imgMap,scale*pixCoord+vec2(2,0));
	vec4 imgHH = texture2DRect(imgMap,scale*pixCoord+vec2(0,-2));
	vec4 imgBB = texture2DRect(imgMap,scale*pixCoord+vec2(0,2));

        vec4 imgHG = texture2DRect(imgMap,scale*pixCoord+vec2(-1,-1));
	vec4 imgHD = texture2DRect(imgMap,scale*pixCoord+vec2(1,-1));
	vec4 imgBG = texture2DRect(imgMap,scale*pixCoord+vec2(-1,1));
	vec4 imgBD = texture2DRect(imgMap,scale*pixCoord+vec2(1,1));*/

        //vec4 img = texture2DRect(imgMap,scale*pixCoord);
        vec4 relax = 0.25*(imgG+imgD+imgH+imgB);

        /*vec4 relax = 0.6*img+0.4*(0.4*(imgG+imgD+imgH+imgB)
                                    -0.1*(imgHG+imgHD+imgBG+imgBD)
                                    -0.05*(imgGG+imgDD+imgHH+imgBB));*/
        
        relax = clamp(relax,vec4(0,0,0,1),vec4(1,1,1,1));

	gl_FragColor = relax;
}
