#include "solvenous.h"
#include <QImage>
#include <iostream>
#include <cmath>
using namespace std;
 
/*
//fonction creer dans catmull:
	QVector<Point> getPointPosition(){return pointPosition;};
	QVector<Point> getPointNormal(){return pointNormal;};
	QVector<QColor> getPointColor(){return pointColor;};
	int getNbPointConstraint(){return nbPointConstraint;};
	fonction modifier dans Catmull:
		drawColorConstraintTriangleStrip

//fonction creer ou a creer dans set_spline: 
	int getNbRefPoint();
	Catmull getSplineCurb(int i);
	int getNbSplines();
//fonction modifier dans poissons viewer
	savePNG
*/


Solvenous::Solvenous(int width, int height){
    _w = width;
    _h = height;
};

Solvenous::~Solvenous(){};


void Solvenous::setParam(SplineSet* s){
	splines = s;   //pas malin
	nbSplines = s->getNbSplines();
	nbRefPoint = s->getNbRefPoint();
}

//compute the weight function given 2 points P and x and a parameter eps
inline double Solvenous::computeWeight(Point P, Point x, Point Normal, double eps){
	/*cout<<"ComputePoids:"<<endl;
	cout<<"     pointX: "<< x.getX()  <<" ; "<< x.getY()<< endl;
	cout<<"     pointP: "<< P.getX()  <<" ; "<< P.getY()<< endl;
	cout<<"                 poids: "<<  1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) + eps*eps) <<endl;
	*/
	double normalScalVec;
	normalScalVec = ((x.getX()-P.getX()) * Normal.getX()) + ((x.getY()-P.getY()) * Normal.getY());//Produit scalaire de la normal avec le vecteur Px
	
	//cout<< "normNormal: "<< Normal.getX()*Normal.getX() + Normal.getY()*Normal.getY() << endl;

		
	if( normalScalVec >= 0){  //peut être mettre une petite marge du genre l'offset de Catmull
		double N_Px = (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) ;
		
		return (1 + abs(normalScalVec/(sqrt(N_Px)))) *(1 + abs(normalScalVec/(sqrt(N_Px))))* (1/(sqrt(N_Px) + eps*eps));
		
		
		//return 1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) + eps*eps );
		//return 1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) - (99999999/100000000) * normalScalVec * normalScalVec + eps*eps);
		//return  1/sqrt((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) +eps*eps ) + 1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) * (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY())  +eps*eps);
		
		//double N_Px = (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) ;
	
		//return 1/(N_Px * N_Px + eps*eps)+1/(N_Px + eps*eps);
	//	return 1/(N_Px + eps*eps) +  1/(N_Px * N_Px + eps*eps) + 1/(N_Px * N_Px * N_Px * N_Px + eps*eps);
	//	return 1/(N_Px + eps*eps) + 1/(N_Px * N_Px * N_Px * N_Px + eps*eps);
			
	}else{
		
		//return 0;
		double N_Px = (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) ;
		
		return (1 + abs(normalScalVec/(sqrt(N_Px))))*(1 + abs(normalScalVec/(sqrt(N_Px)))) * (1/(sqrt(N_Px) + eps*eps));
		
		//return sin(acos(normalScalVec/(sqrt(N_Px)))) * (1/(N_Px + eps*eps));
		
		//return sin(acos(normalScalVec/(sqrt(N_Px))))*(1/( N_Px * N_Px + eps*eps));

		//return sin(acos(normalScalVec/(sqrt(N_Px))))*(1/( pow(N_Px,2-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps)+1/( pow(N_Px,3-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps) +1/( pow(N_Px,4-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps));

		//return (1/( pow(N_Px,2-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps));
		//return (1/( pow(N_Px,2-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps)+1/( pow(N_Px,3-sin(acos(normalScalVec/(sqrt(N_Px))))) + eps*eps));

		//return sin(acos(normalScalVec/( sqrt(N_Px))))*((1/(sqrt(N_Px) + eps*eps)+1/(N_Px*N_Px +eps*eps)));
		//return 1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) + eps*eps);
	}
	
	//return 1/((P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY()) + eps*eps);
}





void Solvenous::savePNG(const QString & fileName){
	int i, j;
	QRgb color;
	QImage Image;
	
	Image = QImage(_w,_h,QImage::Format_RGB32);
	
	for(i=0; i < _w; i++){
					
		cout<< "i:"<< i <<endl;//debug

		for(j=0; j < _h; j++){
			color =computePixel(i,j);
			Image.setPixel(i,j,color);
		}
	}
	
	Image.save (fileName, "PNG",  100 );

}




//compute the color of a given pixel in the image
QRgb Solvenous::computeIntegratedColorPixel(int i, int j, int acc){ 

    double eps = 0.0001; // Weigth function's epsilon (cf paper)

	Point x;
    Catmull c; // current curve
    QVector<Point> cPVec; // QVector of points corresponding to c
    QVector<Point> cPNVec; // QVector of normal at points
    QVector<QColor> cCVec; // QVector of QColor corresponding to c
    Point p1,p2,normp1,normp2;
	int red=0,red1=0,red2=0;
	int green=0,green1=0,green2=0;
	int blue=0,blue1=0,blue2=0;
	double sumW=0; // local var for int w(x,p)² Phi(p) dp)
	double dbRed=0,dbGreen=0,dbBlue=0;
	
//calcul de x;
	x.setX(2*(((double)i)/((double)_w))-1);
	x.setY(-(2*(((double)j)/((double)_h))-1));

	
//Computing of sumWPhi : same value for R,G and B
    // For each spline, sum on the different segments
    for (int m=0; m<nbSplines; m++) {
        c = splines->getSplineCurb(m);
        cPVec = c.getPointPosition();
        cPNVec = c.getPointNormal();
        cCVec = c.getPointColor();
        for (int n=0; n<cPVec.size()-2; n++) {
           // cout<<m<<","<<n<<endl;
            
			/// INtegral
            double pas = 1/( (double) acc );

            //Boucle sur les points d'un coté de la courbe
            for (double t =0 ; t<1; t+=pas) {

                p1 = (cPVec[n+2])*pas+(cPVec[n])*(1-pas);
                p2 = (cPVec[n+2])*(t+pas)+(cPVec[n])*(1-t-pas);
                normp1 = (cPNVec[n+2])*pas+(cPNVec[n])*(1-pas);
                normp2 = (cPNVec[n+2])*(t+pas)+(cPNVec[n])*(1-t-pas);
                
                red1 = pas*( (double) cCVec[n+2].red() )+(1-pas)*( (double) cCVec[n].red() );
                red2 = (t+pas)*( (double) cCVec[n+2].red() )+(1-t-pas)*( (double) cCVec[n].red() );
                
                green1 = pas*( (double) cCVec[n+2].green() )+(1-pas)*( (double) cCVec[n].green() );
                green2 = (t+pas)*( (double) cCVec[n+2].green() )+(1-t-pas)*( (double) cCVec[n].green() );
                
                blue1 = pas*( (double) cCVec[n+2].blue() )+(1-pas)*( (double) cCVec[n].blue() );
                blue2 = (t+pas)*( (double) cCVec[n+2].blue() )+(1-t-pas)*( (double) cCVec[n].blue() );
                
                sumW += 0.5*pas*(computeWeight(p1,x,normp1,eps)  + computeWeight(p2,x,normp2,eps));
                dbRed += 0.5*pas*(computeWeight(p1,x,normp1,eps)*red1  + computeWeight(p2,x,normp2,eps)*red2);
                dbGreen += 0.5*pas*(computeWeight(p1,x,normp1,eps)*green1  + computeWeight(p2,x,normp2,eps)*green2);
                dbBlue += 0.5*pas*(computeWeight(p1,x,normp1,eps)*blue1  + computeWeight(p2,x,normp2,eps)*blue2);
            }
        } 
    }

    red = floor(dbRed/sumW);
    green = floor(dbGreen/sumW);
    blue = floor(dbBlue/sumW);
	
	return qRgb(red,green,blue);
}

inline void Solvenous::computeConstraint(Point x, Point P, Point Normal, QColor Cright, QColor Cleft, double Blur, double diff, double& fading, double& weight, double& red, double& green, double& blue){

	double rCarre = (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY());
	weight = 1/( rCarre + 0.0001);//1/( pow(rCarre,2) + 0.0001);//computeWeight(P, x, Normal, 0.001);//1/( rCarre + 0.0001); //1/( 5000 * rCarre + 0.0001); //1/( 500000 * rCarre*rCarre*rCarre + 0.0001);//1/( rCarre + 0.0001); //computeWeight(Middle, x, Normal, 0.001);// 1/((Middle.getX()-x.getX())*(Middle.getX()-x.getX()) + (Middle.getY()-x.getY())*(Middle.getY()-x.getY()) + 0.0001);  //remplacer le 0.0001 par une fonction du blur
	//mieu que 1/(rCarre+eps) en effet le degrade n est pas assez progressif dans ce cas??

	/*
	//test fonction de poid
	Point PX = x - P;
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();
	double phi = acos(abs(Side/sqrt(rCarre))-0.01); 
	//weight = 5*(2 - sin(phi))*1/( rCarre + 0.0001);
	weight = 5*(1 + cos(phi))*1/( rCarre + 0.0001);	
	//
	/**/

	fading =1;// exp(-rCarre/(diff));   // fonction de diff 

	red   = colorConstraint(x, P, Normal, (double) Cleft.red(),   (double) Cright.red(), Blur,  rCarre);
	green = colorConstraint(x, P, Normal, (double) Cleft.green(), (double) Cright.green(), Blur,  rCarre);
	blue  = colorConstraint(x, P, Normal, (double) Cleft.blue(),  (double) Cright.blue(), Blur,  rCarre);
}

inline void Solvenous::computeExtremityConstraint(Point x, Point P, Point Normal, QColor Cright, QColor Cleft, double Blur, double diff, double& fading, double& weight, double& red, double& green, double& blue, bool debut){

	double rCarre = (P.getX()-x.getX())*(P.getX()-x.getX()) + (P.getY()-x.getY())*(P.getY()-x.getY());
	weight = 2 * 1/( rCarre + 0.0001); //4 * 1/( pow(rCarre,2) + 0.0001);//computeWeight(P, x, Normal, 0.001);//2 * 1/( rCarre + 0.0001); //2 * 1/( 5000 * rCarre + 0.0001);//2 * 1/( 500000 * rCarre*rCarre*rCarre + 0.0001);//1/( rCarre + 0.0001); //computeWeight(Middle, x, Normal, 0.001);// 1/((Middle.getX()-x.getX())*(Middle.getX()-x.getX()) + (Middle.getY()-x.getY())*(Middle.getY()-x.getY()) + 0.0001);  //remplacer le 0.0001 par une fonction du blur
	//mieu que 1/(rCarre+eps) en effet le degrade n est pas assez progressif dans ce cas??

/*
	//test poids
	weight = 10/( rCarre + 0.0001);
/**/

	
	fading =1;// exp(-rCarre/(diff));   // fonction de diff 

	red   = colorExtremityConstraint(x, P, Normal, (double) Cleft.red(),   (double) Cright.red(), Blur,  rCarre, debut);
	green = colorExtremityConstraint(x, P, Normal, (double) Cleft.green(), (double) Cright.green(), Blur,  rCarre, debut);
	blue  = colorExtremityConstraint(x, P, Normal, (double) Cleft.blue(),  (double) Cright.blue(), Blur,  rCarre, debut);
}

inline QRgb Solvenous::computePixel(int i, int j){
	Point x;
	int red;
	int green;
	int blue;

	Catmull c;
	QVector<Point> vP;
	QVector<Point> vN;
	QVector<QColor> vC;
	QVector<int> vB;

	int l, k;

	double sWeight = 0, sRed = 0, sGreen = 0, sBlue = 0; 
	
	double Blur = 0.05;//0.1 moyen //0.2; permet d'obtenir un blur assez important //will be computed thinks to a new vector
	double Diff = 10; 
	
	double fading; 
	double weight; 
	double Cred, Cgreen, Cblue;

	double pW;

	//calcul de x;
	x.setX(2*(((double)i)/((double)_w))-1);
	x.setY(-(2*(((double)j)/((double)_h))-1));
	
	for(l=0; l < nbSplines; l++){
		c = splines->getSplineCurb(l);
		vP = c.getPointPosition();
		vN = c.getPointNormal();
		vC = c.getPointColor();
		vB = c.getPointBlur();
	
	
		int kmax = c.getNbConstraint()-1;
	
		
		if(vP[0] == vP[kmax]){//il faudrai remplacer mais il semble sue l'autre ne marche pas
		//if(c.isClosedCurve()){
		
			computeConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/100, Diff, fading, weight, Cred, Cgreen, Cblue);
			pW = weight*weight;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

			/*
			computeConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], 1/((double) vB[kmax]), Diff, fading, weight, Cred, Cgreen, Cblue);
			pW = weight*weight;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);
			*/

		}else{
		
			computeExtremityConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/100, Diff, fading, weight, Cred, Cgreen, Cblue,true);
			pW = weight*weight;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

			computeExtremityConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], ((double) vB[kmax])/100, Diff, fading, weight, Cred, Cgreen, Cblue,false);
			pW = weight*weight;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

		
		
		}
		
		
		for(k=1; k < c.getNbConstraint()-1; k++){
			
			computeConstraint(x, vP[k], vN[k], vC[2*k], vC[2*k+1], ((double) vB[k])/100, Diff, fading, weight, Cred, Cgreen, Cblue);
			pW = weight*weight;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);
		}
	}

	red = (int) (sRed/sWeight);
	green = (int) (sGreen/sWeight);
	blue = (int) (sBlue/sWeight);
	
	return qRgb(red,green,blue);

}


inline QRgb Solvenous::computePixelCont(int i, int j){
	Point x;
	int red;
	int green;
	int blue;

	Catmull c;
	QVector<Point> vP;
	QVector<Point> vN;
	QVector<QColor> vC;
	QVector<int> vB;

	int l, k;

	double sWeight = 0, sRed = 0, sGreen = 0, sBlue = 0; 
	
	double Blur = 0.05;//0.1 moyen //0.2; permet d'obtenir un blur assez important //will be computed thinks to a new vector
	double Diff = 10; 
	
	double fading; 
	double weight; 
	double Cred, Cgreen, Cblue;

	double pW;
	double segLong; // Longueur du segment, pour faire la methode des trapezes

	//calcul de x;
	x.setX(2*(((double)i)/((double)_w))-1);
	x.setY(-(2*(((double)j)/((double)_h))-1));
	
	for(l=0; l < nbSplines; l++){
		c = splines->getSplineCurb(l);
		vP = c.getPointPosition();
		vN = c.getPointNormal();
		vC = c.getPointColor();
		vB = c.getPointBlur();
	
	
		int kmax = c.getNbConstraint()-1;
	
		
		if(vP[0] == vP[kmax]){//il faudrai remplacer mais il semble sue l'autre ne marche pas
		//if(c.isClosedCurve()){
		
			computeConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/100, Diff, fading, weight, Cred, Cgreen, Cblue);
			segLong = ((vP[1]-vP[0]).L2_norm())/2;
			pW = weight*weight*segLong;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

			computeConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], ((double) vB[kmax])/16, Diff, fading, weight, Cred, Cgreen, Cblue);
			segLong = ((vP[kmax]-vP[kmax-1]).L2_norm())/2;			
			pW = weight*weight*segLong;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

		}else{
		
			computeExtremityConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/16, Diff, fading, weight, Cred, Cgreen, Cblue,true);
			segLong = ((vP[1]-vP[0]).L2_norm())/2;
			pW = weight*weight*segLong;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

			computeExtremityConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], ((double) vB[kmax])/16, Diff, fading, weight, Cred, Cgreen, Cblue,false);
			segLong =((vP[kmax]-vP[kmax-1]).L2_norm())/2;
			pW = weight*weight*segLong;
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);

		
		
		}
		
		
		for(k=1; k < c.getNbConstraint()-1; k++){
			
			computeConstraint(x, vP[k], vN[k], vC[2*k], vC[2*k+1], ((double) vB[k])/100, Diff, fading, weight, Cred, Cgreen, Cblue);
			segLong = (((vP[k]-vP[k-1]).L2_norm()) + ((vP[k+1]-vP[k]).L2_norm()))/2;
			pW = weight*weight*segLong;	
			sWeight += pW;
			sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0);
			sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0);
			sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0);
		}
	}

	red = (int) (sRed/sWeight);
	green = (int) (sGreen/sWeight);
	blue = (int) (sBlue/sWeight);
	
	return qRgb(red,green,blue);

}


inline QRgb Solvenous::computePixelContTrapeze(int i, int j, double dist){
	Point x;
	int red;
	int green;
	int blue;

	Catmull c;
	QVector<Point> vP;
	QVector<Point> vN;
	QVector<QColor> vC;
	QVector<int> vB;

	int l, k;

	double sWeight = 0, sRed = 0, sGreen = 0, sBlue = 0; 
	
	double Blur = 0.05;//0.1 moyen //0.2; permet d'obtenir un blur assez important //will be computed thinks to a new vector
	double Diff = 10; 
	
	double fading; 
	double weight; 
	double Cred, Cgreen, Cblue;

	double pW;

	double qTrap; // coefficent pour la méthode d'approximation des trapèzes

	//calcul de x;
	x.setX(2*(((double)i)/((double)_w))-1);
	x.setY(-(2*(((double)j)/((double)_h))-1));
	
	for(l=0; l < nbSplines; l++){
		c = splines->getSplineCurb(l);
		vP = c.getPointPosition();
		vN = c.getPointNormal();
		vC = c.getPointColor();
		vB = c.getPointBlur();
	
	
		int kmax = c.getNbConstraint()-1;
	
		

		
		
		for(k=0; k < c.getNbConstraint()-1; k++){

			Point Paux,PNaux;
			QColor PCraux, PClaux;
			double longSegment = (vP[k]-vP[k+1]).L2_norm();
			double PBlaux;
			int limit = floor(longSegment/dist)+1;
			for (int i = 0; i < limit; i++) {
				if (k!=0 && i!=0) {
					Paux = vP[k]*(1-((double) (i/limit))) + vP[k+1]*((double) (i/limit));
					PNaux = vN[k]*(1-((double) (i/limit))) + vN[k+1]*((double) (i/limit));
					PNaux.normalize();
					PCraux = QColor(
							vC[2*k].red()*((limit-i)/limit) + vC[2*k+2].red()*(i/limit),
							vC[2*k].green()*((limit-i)/limit) + vC[2*k+2].green()*(i/limit),
							vC[2*k].blue()*((limit-i)/limit) + vC[2*k+2].blue()*(i/limit)
							);
					PCraux = QColor(
							vC[2*k+2].red()*((limit-i)/limit) + vC[2*k+3].red()*(i/limit),
							vC[2*k+2].green()*((limit-i)/limit) + vC[2*k+3].green()*(i/limit),
							vC[2*k+2].blue()*((limit-i)/limit) + vC[2*k+3].blue()*(i/limit)
						      );
					double PBlaux = ((double) (vB[k]*((limit-i)/limit) + vB[k+1]*(i/limit)))/100;
					computeConstraint(x, Paux, PNaux, PCraux, PClaux, PBlaux, Diff, fading, weight, Cred, Cgreen, Cblue);			
					pW = weight*weight;					
					if (i==0) {
						sWeight += pW*(longSegment/ ((double) limit))/2;
						sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0)*((longSegment/ ((double) limit))+ qTrap)/2;
						sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0)*((longSegment/ ((double) limit))+ qTrap)/2;
						sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0)*((longSegment/ ((double) limit))+ qTrap)/2;
				        }else {
						sWeight += pW;
						sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0)*(longSegment/ ((double) limit));
						sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0)*(longSegment/ ((double) limit));
						sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0)*(longSegment/ ((double) limit));
					}
				}else { // on est dans le cas du 1er point de la courbe consideree
				
					if(vP[0] == vP[kmax]){//il faudrai remplacer mais il semble sue l'autre ne marche pas
					//if(c.isClosedCurve()){
						computeConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/100, Diff, fading, weight, Cred, Cgreen, Cblue);
					}else{
						computeExtremityConstraint(x, vP[0], vN[0], vC[0], vC[1], ((double) vB[0])/100, Diff, fading, weight, Cred, Cgreen, Cblue,true);
					}
					pW = weight*weight;
					sWeight += pW*(longSegment/ ((double) limit))/2;
					sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0)*(longSegment/ ((double) limit))/2;
					sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0)*(longSegment/ ((double) limit))/2;
					sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0)*(longSegment/ ((double) limit))/2;

				}
			} 
			qTrap = longSegment/((double) limit);
		}

		if (vP[0] == vP[kmax]) {	
			computeConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], ((double) vB[kmax])/100, Diff, fading, weight, Cred, Cgreen, Cblue);

		}else{
			computeExtremityConstraint(x, vP[kmax], vN[kmax], vC[2*kmax], vC[2*kmax+1], ((double) vB[kmax])/100, Diff, fading, weight, Cred, Cgreen, Cblue,false);
		}
		pW = weight*weight;
		sWeight += pW*qTrap/2;
		sRed   += pW * ( (fading) * Cred   + (1 - fading) * 255.0)*qTrap/2;
		sGreen += pW * ( (fading) * Cgreen + (1 - fading) * 255.0)*qTrap/2;
		sBlue  += pW * ( (fading) * Cblue  + (1 - fading) * 255.0)*qTrap/2;

	}

	red = (int) (sRed/sWeight);
	green = (int) (sGreen/sWeight);
	blue = (int) (sBlue/sWeight);
	
	return qRgb(red,green,blue);

}


#define PI 3.14159265
/*inline double Solvenous::colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	if (Side<0) {
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}else{
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;
		}

	return res;

}*/
/*
inline double Solvenous::colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	double blurEffect = 1;
	double aux = abs(Side);
	//aux = sqrt(rCarre);
	if ( aux < blur) {
		blurEffect = (-1/(blur*blur))*aux*(aux-2*blur);
		//blurEffect = aux/blur;

	}
	
	


	if (Side<0) {
			res = L*(Cleft*blurEffect+(1-blurEffect)*(Cright+Cleft)/2) + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}else{
			res = L*(Cright*blurEffect+(1-blurEffect)*(Cleft+Cright)/2) + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;
		}

	return res;

}
*/
/*
inline double Solvenous::colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res,aux;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	// Should be useless
	rCarre = PX.getX()*PX.getX() + PX.getY()*PX.getY();
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	Point Tan(-Normal.getY(),Normal.getX());
	
	double TanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();


	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	double phiaux = acos(abs( sqrt( blur*blur-TanSide*TanSide )/blur   ) -0.01);
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	double eaux = (phiaux-(PI/2))*(phiaux+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	double Laux = exp(-(blur*blur) *150);
	double Lauxp = 1-Laux;

	//double blurEffect = exp(- rCarre * (50/blur));


	if (Side<0) {
		if (sqrt(rCarre)>blur) {
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);
		}else {
			aux = (Laux*Cleft + Lauxp * (eaux*Cleft + (1-eaux)*(Cright + Cleft)/2));
            		//res = ((Cright + Cleft)/2)*(1-(abs(Side)/blur)) + aux*(abs(Side)/blur);
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-TanSide*TanSide))*(-1/(blur*blur-TanSide*TanSide));
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}else{
		if (sqrt(rCarre)>blur) {
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);
		}else {
			aux = (Laux*Cright + Lauxp * (eaux*Cright + (1-eaux)*(Cright + Cleft)/2));
			//res = ((Cright + Cleft)/2)*(1-(abs(Side)/blur)) + aux*(abs(Side)/blur);
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-TanSide*TanSide))*( -1/ (blur*blur-TanSide*TanSide) );
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}

	return res;
}
*/

inline double Solvenous::colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res,aux;	

	// coefficient for the blending
	double L, Lp, e;

	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir

	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	if (Side<0) {
		if (sqrt(rCarre)>blur) {
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);
		}else {
			Point Tan(-Normal.getY(),Normal.getX());
			double TanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();
			double phiaux = acos(abs( sqrt( blur*blur-(TanSide*TanSide) )/blur   ) -0.01);
			double eaux = (phiaux-(PI/2))*(phiaux+(PI/2))*(-4/(PI*PI));
			double Laux = exp(-(blur*blur) *150);
			double Lauxp = 1-Laux;
			aux = (Laux*Cleft + Lauxp * (eaux*Cleft + (1-eaux)*(Cright + Cleft)/2));
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-(TanSide*TanSide)))*(-1/(blur*blur-(TanSide*TanSide)));
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}else{
		if (sqrt(rCarre)>blur) {
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);
		}else {
			Point Tan(-Normal.getY(),Normal.getX());
			double TanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();
			double phiaux = acos(abs( sqrt( blur*blur-(TanSide*TanSide) )/blur   ) -0.01);
			double eaux = (phiaux-(PI/2))*(phiaux+(PI/2))*(-4/(PI*PI));
			double Laux = exp(-(blur*blur) *150);
			double Lauxp = 1-Laux;
			aux = (Laux*Cright + Lauxp * (eaux*Cright + (1-eaux)*(Cright + Cleft)/2));
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-(TanSide*TanSide)))*( -1/ (blur*blur-(TanSide*TanSide)) );
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}

	return res;
}
/*
inline double Solvenous::colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res,aux;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	double Laux = exp(-(blur*blur) *150);
	double Lauxp = 1-Laux;

	//double blurEffect = exp(- rCarre * (50/blur));


	if (Side<0) {
		if (sqrt(rCarre)>blur) {
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}else {
			aux = (Laux*Cleft + Lauxp * (e*Cleft + (1-e)*(Cright + Cleft)/2));
            		//res = ((Cright + Cleft)/2)*(1-(abs(Side)/blur)) + aux*(abs(Side)/blur);
			//res = abs(Side)*(abs(Side)+2*blur)*(-1/(blur*blur));
            		res = sqrt(rCarre)*(sqrt(rCarre)-2*blur)*(-1/(blur*blur));
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}else{
		if (sqrt(rCarre)>blur) {
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;
		}else {
			aux = (Laux*Cright + Lauxp * (e*Cright + (1-e)*(Cright + Cleft)/2));
			//res = ((Cright + Cleft)/2)*(1-(abs(Side)/blur)) + aux*(abs(Side)/blur);
			//res = abs(Side)*(abs(Side)+2*blur)*(-1/(blur*blur));
			res = sqrt(rCarre)*(sqrt(rCarre)-2*blur)*(-1/(blur*blur));
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
	}

	return res;

}

*/





/*inline double Solvenous::colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	if (Side<0) {
			res = (e*Cleft + (1-e)*(Cright + Cleft)/2);
			//res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}else{
			//res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;
			res = (e*Cright + (1-e)*(Cright + Cleft)/2);
		}

	return res;

}

*/
/*
inline double Solvenous::colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre, bool debut){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	//to know where is x with respect to the tangeant
	Point Tan(Normal.getY(),-Normal.getX());
	double tanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	if (Side<0) {
		
		if (tanSide >0) {
			res = (e*Cleft + (1-e)*(Cright + Cleft)/2);
		}else{
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}
	}else{
		if (tanSide >0) {
			res = (e*Cright + (1-e)*(Cright + Cleft)/2);
		}else{
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;		
		}
	}

	return res;

}
*/

/*

inline double Solvenous::colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre, bool debut){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	//to know where is x with respect to the tangeant
	
	Point Tan;
	if (debut) {
		Tan = Point(-Normal.getY(),Normal.getX());
	}else{
		Tan = Point(Normal.getY(),-Normal.getX());
	}

	double tanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();


	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	double blurEffect = 1;
	double aux = abs(Side);
	if ( aux < blur) {
		blurEffect = (-1/(blur*blur))*aux*(aux-2*blur);
	}
	

	if (Side<0) {
		
		if (tanSide >0) {
			res = (e*Cleft + (1-e)*(Cright + Cleft)/2);
		}else{
			res = L*(Cleft*blurEffect+(1-blurEffect)*(Cright+Cleft)/2) + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}
	}else{
		if (tanSide >0) {
			res = (e*Cright + (1-e)*(Cright + Cleft)/2);
		}else{
			res = L*(Cright*blurEffect+(1-blurEffect)*(Cleft+Cright)/2) + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;		
		}
	}

	return res;

}


*/


/*
inline double Solvenous::colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre, bool debut){

	// result
	double res;	

	// coefficient for the melting
	double L, Lp, e;

	// Offset : equal to the distance between Pright and Pleft
	// This is necessary because the other offset is local.
		
	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	//to know where is x with respect to the tangeant
	Point Tan;
	if (debut) {
		Tan = Point(-Normal.getY(),Normal.getX());
	}else{
		Tan = Point(Normal.getY(),-Normal.getX());
	}
	double tanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();


	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir
	
	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	double blurEffect = 1;
	double aux; 
	if (tanSide>0) {
		aux = sqrt(rCarre);
	}else{
		//aux = sqrt(rCarre);
		aux = abs(Side);
	}
	if ( aux < blur) {
		blurEffect = (-1/(blur*blur))*aux*(aux-2*blur);
		//blurEffect = aux/blur;
	}
	
	double resAux;

	if (Side<0) {
		
		resAux = L*(Cleft*blurEffect+(1-blurEffect)*(Cright+Cleft)/2) + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);		

		if (tanSide >0) {
			res = (e*Cleft + (1-e)*(Cright + Cleft)/2)*blurEffect+(1-blurEffect)*(Cright+Cleft)/2;
			res = e*resAux + (1-e)*res;
		}else{
			res = L*(Cleft*blurEffect+(1-blurEffect)*(Cright+Cleft)/2) + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cleft + (Lp *(1 + e)) * Cright)/2;
		}
	}else{

		resAux = L*(Cright*blurEffect+(1-blurEffect)*(Cleft+Cright)/2) + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);		

		if (tanSide >0) {
			res = (e*Cright + (1-e)*(Cright + Cleft)/2)*blurEffect+(1-blurEffect)*(Cleft+Cright)/2;
			res = e*resAux + (1-e)*res;
		}else{
			res = L*(Cright*blurEffect+(1-blurEffect)*(Cleft+Cright)/2) + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);//((1 + L + Lp*e) * Cright + (Lp *(1 + e)) * Cleft)/2;		
		}
	}

	return res;

}
*/


inline double Solvenous::colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre, bool debut){


		// result
	double res,aux,resSpecial;	

	// coefficient for the blending
	double L, Lp, e;

	//vector from the center toward x
	Point PX = x - P;
	
	//give in which side of the curve is x 
	double Side = Normal.getX() * PX.getX() + Normal.getY() * PX.getY();

	//to know where is x with respect to the tangeant
	Point Tan;
	if (debut) {
		Tan = Point(-Normal.getY(),Normal.getX());
	}else{
		Tan = Point(Normal.getY(),-Normal.getX());
	}
	double TanSide = Tan.getX() * PX.getX() + Tan.getY() * PX.getY();

	double phi = acos(abs(Side/sqrt(rCarre))-0.01); //peut expliquer la presence de point noir

	//e sert au calcul de l'influence loin
	e = (phi-(PI/2))*(phi+(PI/2))*(-4/(PI*PI));
	
	//L sert a determiner si l on utilise l'influence local ou si on utilise l'influence eloigne on a L=1-Lp
	L = exp(- rCarre * 150); //100 peut etre mieu car plus intense //avec 100 correct avec 150 aussi ca depend du rendu voulu //peut etre faire varier en fonction de la diffusion
	Lp=1-L;

	if (Side<0) {
		if (sqrt(rCarre)>blur) {
			res = L*Cleft + Lp * (e*Cleft + (1-e)*(Cright + Cleft)/2);
		}else {
			double phiaux = acos(abs( sqrt( blur*blur-(TanSide*TanSide) )/blur   ) -0.01);
			double eaux = (phiaux-(PI/2))*(phiaux+(PI/2))*(-4/(PI*PI));
			double Laux = exp(-(blur*blur) *150);
			double Lauxp = 1-Laux;
			aux = (Laux*Cleft + Lauxp * (eaux*Cleft + (1-eaux)*(Cright + Cleft)/2));
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-(TanSide*TanSide)))*(-1/(blur*blur-(TanSide*TanSide)));
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}

		if (TanSide >0) {
			double blurEffect = 1;
			double aux = sqrt(rCarre);//abs(Side);
			if ( aux < blur) {
				blurEffect = (-1/(blur*blur))*aux*(aux-2*blur);
			}
			resSpecial = (e*Cleft + (1-e)*(Cright + Cleft)/2)*blurEffect+(1-blurEffect)*(Cright+Cleft)/2;
			res = e*res + (1-e)*resSpecial;
		}
		
	}else{
		if (sqrt(rCarre)>blur) {
			res = L*Cright + Lp * (e*Cright + (1-e)*(Cright + Cleft)/2);
		}else {
			double phiaux = acos(abs( sqrt( blur*blur-(TanSide*TanSide))/blur   ) -0.01);
			double eaux = (phiaux-(PI/2))*(phiaux+(PI/2))*(-4/(PI*PI));
			double Laux = exp(-(blur*blur) *150);
			double Lauxp = 1-Laux;
			aux = (Laux*Cright + Lauxp * (eaux*Cright + (1-eaux)*(Cright + Cleft)/2));
			res = abs(Side)*(abs(Side)-2*sqrt(blur*blur-(TanSide*TanSide)))*( -1/ (blur*blur-(TanSide*TanSide)) );
			res = res*aux + (1-res)*((Cright + Cleft)/2);
		}
		if (TanSide >0) {
			double blurEffect = 1;
			double aux = sqrt(rCarre);//abs(Side);
			if ( aux < blur) {
				blurEffect = (-1/(blur*blur))*aux*(aux-2*blur);
			}
			resSpecial = (e*Cright + (1-e)*(Cright + Cleft)/2)*blurEffect+(1-blurEffect)*(Cleft+Cright)/2;
			res = e*res + (1-e)*resSpecial;
		}
	}

	return res;

}





inline double Solvenous::weightFctGauss(Point Pleft, Point Pright, Point x, double sigma){

	Point center = (Pleft + Pright)/2;
	double r2 = center.getX()*x.getX() + center.getY()*x.getY();

	return ( (1/(sigma*sqrt(2*PI)))*exp(-r2/(2*sigma*sigma)));
	
}

