
#ifndef SOLVERNous_H
#define SOLVERNous_H

#include "spline_set.h"
#include "matrix.h"
#include <QVector>
#include <QString>


class Solvenous
{
	public:
		Solvenous(int width, int heihgt);
		~Solvenous();
		void setParam(SplineSet* s);
		void savePNG(const QString & fileName);

	private:
		//curves
        SplineSet* splines;
		int nbSplines;
		
		//constraint
		int nbRefPoint;  //number of ColorPoint and PositionPoint
		
		static const int nbBasisFunction=1;
        
		//image size
        int _w, _h;
        			
		double computeWeight(Point P, Point x, Point Normal, double eps);//compute the weight function given 2 points P and x and a parameter eps
		
		double colorConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre);
		double colorExtremityConstraint(Point x, Point P, Point Normal, double Cleft, double Cright, double blur, double rCarre, bool debut);

		double weightFctGauss(Point Pleft, Point Pright, Point x, double sigma);
		
		void computeConstraint(Point x, Point P, Point Normal, QColor Cright, QColor Cleft, double Blur, double diff, double& fading, double& weight, double& red, double& green, double& blue); //compute alpha, omega, phi for the function computePixel
		void computeExtremityConstraint(Point x, Point P, Point Normal, QColor Cright, QColor Cleft, double Blur, double diff, double& fading, double& weight, double& red, double& green, double& blue, bool debut);


		QRgb computeIntegratedColorPixel(int i, int j, int acc);
		QRgb computePixel(int i, int j);
		inline QRgb computePixelCont(int i, int j);
		inline QRgb computePixelContTrapeze(int i, int j, double dist);
};

#endif

